Foreman - Feature #26608

Windows password hashes require 'AdministratorPassword’ at the end of passwd string
04/14/2019 11:32 AM - Si Man

Status: Closed

Priority: Normal

Assignee: Arend Lapere
Category: Unattended installations

Target version:

Difficulty: Fixed in Releases: 1.24.1,2.0.0
Triaged: No Found in Releases: 1.21.2
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/7339,

https://github.com/theforeman/foreman/p

ull/7131
Description

Windows OS's that | have tested (2012r2 to 10.1809) require the string "AdministratorPassword" to be appended to the end of the
raw password string prior to hashing, which must then be in UTF16LE format. While the hashing method is now included in the latest
1.21.2 release as 'Base-64-Windows' option under Operating System, the additional string is not. Windows (Unattended) Answer
files (.xml) encapsulated in provisioning templates (.erb) cannot be processed by the OS unless this string exists at the end of the
password when <%= root_pass > is used.

case hash_alg
when 'Base64'
result = Baseb4.strict_encode64 (passwd)
when 'Base64-Windows'
* passwd << Baseb64.strict_encodeb4 ("AdministratorPassword") *
result = Baseb64.strict_encodeb4 (passwd.encode ('utf-16le'))

The attached password_crypt.rb file has an additional line that appends the passwd with the required string.
Templates tested were originally sourced from

https://github.com/kireevco/foreman-wimaging/tree/1bd8f0facff80c19a5eccc12c01e8febd00f701e/wimaging and have been
customised to my environment.

Related issues:
Related to Foreman - Bug #35946: Windows password-encryption code changes inp... Closed

Associated revisions

Revision 0Ode4e199 - 10/29/2019 04:11 PM - UXabre

Fixes #26608 - suffixed "AdministratorPassword" for windows

History

#1 - 04/17/2019 08:56 AM - Si Man
- File password_crypt.rb added

Further testing has shown that the appending of AdministratorPassword does NOT need to be base64 encoded prior to adding to the passwd
contents. The following line is enough:

when 'Base64-Windows'
passwd << "AdministratorPassword"
result = Baseb6b4.strict_encodeb64 (passwd.encode ('utf-16le'))

Also, if a default password is saved in a Host Group it appears to be stored in a hash other than UTF16LE, and the result fails to create a host.
Therefore, a password must not be stored in a Host Group and needs to be assigned to a Host upon creation.

Found 2 side-effects of this method however:

1. The build token cannot be successfully retrieved. Unsure why appending the passwd would cause this, but removing the line fixed this issue
2. Cancelling a build results in a password length error, but building or deleting a Host completes OK.
https://github.com/kireevco/foreman-wimaging/tree/1bd8f0facff80c19a5eccc12c01e8febd00f701e/wimaging

#2 - 04/17/2019 08:56 AM - Si Man
- File deleted (password_crypt.rb)

#3 - 10/25/2019 01:57 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Arend Lapere

- Pull request https://github.com/theforeman/foreman/pull/7131 added

#4 - 10/29/2019 04:12 PM - The Foreman Bot
- Fixed in Releases 2.0.0 added

#5 - 10/29/2019 05:02 PM - Anonymous
- Status changed from Ready For Testing to Closed

Applied in changeset 0de4e199bc95e4544c26c093ab0839ffbba8cb64.

#6 - 01/07/2020 04:14 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/7339 added

#7 - 01/08/2020 03:09 PM - Tomer Brisker
- Fixed in Releases 1.24.1 added

#8 - 01/08/2020 03:17 PM - Tomer Brisker

- Category set to Unattended installations

#9 - 01/13/2023 05:22 PM - Markus Bucher
- Related to Bug #35946: Windows password-encryption code changes input-value added

Files

password_crypt.rb 1.29 KB 04/17/2019
